{ fetchFromGitHub, fetchpatch, buildNeovimPlugin }:
let
  plugins = builtins.fromJSON (builtins.readFile ./sources.json);

  overrides = {
    "tpope/vim-fugitive" = {
      patches = [ ./fugitive-origin-head.patch ];
    };

    "leafgarland/typescript-vim" = {
      patches = [
        # make compiler build entire project
        ./typescript-vim-compiler.patch
      ];
    };

    "nvim-telescope/telescope-fzf-native.nvim" = {
      dontBuild = false;
    };
  };

  buildPlugin = name: spec:
    let
      nameParts = builtins.split "/" name;
      owner = builtins.head nameParts;
      repo = builtins.elemAt nameParts 2;
    in
    buildNeovimPlugin ({
      name = repo;

      src = fetchFromGitHub {
        inherit owner repo;
        inherit (spec) rev sha256;
      };

      dontBuild = true;
    } // (overrides.${name} or {}));
in
builtins.mapAttrs buildPlugin plugins
